﻿using AutoMapper;
using System;
using System.Collections.Generic;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using Tsi1.BusinessLayer.Dtos;
using Tsi1.DataLayer.Entities;

namespace Tsi1.BusinessLayer.Helpers
{
    public class MappingProfile : Profile
    {
        public MappingProfile()
        {
            CreateMap<Forum, ForumCreateDto>();
            CreateMap<Forum, ForumPreviewDto>();
            CreateMap<Post, PostCreateDto>();
            CreateMap<Post, PostPreviewDto>();
            CreateMap<PostMessage, PostMessageCreateDto>();
            CreateMap<PostMessage, PostMessagePreviewDto>();
            CreateMap<Message, MessagePreviewDto>();
            CreateMap<Message, MessageCreateDto>();
            CreateMap<User, UserDetailDto>();
            CreateMap<User, UserRegisterDto>();
            CreateMap<User, UserModifyDto>();
            CreateMap<User, UserPreviewDto>();
            CreateMap<Student, StudentPreviewDto>();
            CreateMap<Professor, ProfessorPreviewDto>();
            CreateMap<Course, CourseCreateDto>();
            CreateMap<Course, CoursePreviewDto>();
            CreateMap<Tenant, TenantPreviewDto>();
            CreateMap<Tenant, TenantCreateDto>();
            CreateMap<Tenant, TenantCourseDto>().ForMember(x => x.Courses, opt => opt.Ignore());         
            CreateMap<UserType, UserTypeDto>();
            CreateMap<File, FileDto>();
            CreateMap<SectionItem, SectionItemCreateDto>();
            CreateMap<Section, SectionCreateDto>();
            CreateMap<SectionItemType, SectionItemTypeDto>();       
            CreateMap<Course, CourseDetailDto>();
            CreateMap<Section, SectionDetailDto>();
            CreateMap<SectionItem, SectionItemDetailDto>();
            CreateMap<File, FileDetailDto>();
            CreateMap<Survey, SurveyCreateDto>();
            CreateMap<Survey, SurveyPreviewDto>();
            CreateMap<Survey, SurveyDetailDto>();
            CreateMap<SurveyQuestion, SurveyQuestionCreateDto>();
            CreateMap<SurveyQuestion, SurveyQuestionPreviewDto>();
            CreateMap<SurveyResponse, SurveyResponseCreateDto>();
            CreateMap<SurveyResponse, SurveyResponseDetailDto>();
            CreateMap<SurveyAnswer, SurveyAnswerDetailDto>();
            CreateMap<SurveyAnswer, SurveyAnswerCreateDto>();
            CreateMap<Communication, CommunicationCreateDto>();
            CreateMap<Communication, CommunicationPreviewDto>();
            CreateMap<AnswerOption, AnswerOptionDetailDto>();
            CreateMap<Tenant, RegistrationDto>();
            CreateMap<Course, RegistrationDto>();
            CreateMap<Activity, ActivityCreateDto>();
            CreateMap<Activity, ActivityModifyDto>();
            CreateMap<Activity, ActivityDto>();
            CreateMap<EvaluationType, EvaluationTypeDto>();
            CreateMap<Evaluation, EvaluationCreateDto>();
            CreateMap<Evaluation, EvaluationModifyDto>();
            CreateMap<Evaluation, EvaluationDetailDto>();
            CreateMap<EvaluationInscription, EvaluationInscriptionDto>();

            CreateMap<ForumCreateDto, Forum>();
            CreateMap<ForumPreviewDto, Forum>();
            CreateMap<PostCreateDto, Post>();
            CreateMap<PostPreviewDto, Post>();
            CreateMap<PostMessageCreateDto, PostMessage>();
            CreateMap<PostMessagePreviewDto, PostMessage>();
            CreateMap<MessagePreviewDto, Message>();
            CreateMap<MessageCreateDto, Message>();
            CreateMap<UserDetailDto, User>();
            CreateMap<UserRegisterDto, User>();
            CreateMap<UserModifyDto, User>();
            CreateMap<UserPreviewDto, User>();
            CreateMap<StudentPreviewDto, Student>();
            CreateMap<ProfessorPreviewDto, Professor>();
            CreateMap<CourseCreateDto, Course>();
            CreateMap<CoursePreviewDto, Course>();
            CreateMap<TenantPreviewDto, Tenant>();
            CreateMap<TenantCreateDto, Tenant>();
            CreateMap<TenantCourseDto, Tenant>();
            CreateMap<UserTypeDto, UserType>();
            CreateMap<FileDto, File>();
            CreateMap<SectionItemCreateDto, SectionItem>();
            CreateMap<SectionCreateDto, Section>();
            CreateMap<SectionItemTypeDto, SectionItemType>();
            CreateMap<CourseDetailDto, Course>();
            CreateMap<SectionDetailDto, Section>();
            CreateMap<SectionItemDetailDto, SectionItem>();
            CreateMap<FileDetailDto, File>();
            CreateMap<SurveyCreateDto, Survey>();
            CreateMap<SurveyDetailDto, Survey>();
            CreateMap<SurveyPreviewDto, Survey>();
            CreateMap<SurveyQuestionCreateDto, SurveyQuestion>();
            CreateMap<SurveyQuestionPreviewDto, SurveyQuestion>();
            CreateMap<SurveyResponseCreateDto, SurveyResponse>();
            CreateMap<SurveyResponseDetailDto, SurveyResponse>();
            CreateMap<SurveyAnswerDetailDto, SurveyAnswer>();
            CreateMap<SurveyAnswerCreateDto, SurveyAnswer>();
            CreateMap<CommunicationCreateDto, Communication>();
            CreateMap<CommunicationPreviewDto, Communication>();
            CreateMap<AnswerOptionDetailDto, AnswerOption>();
            CreateMap<RegistrationDto, Tenant>();
            CreateMap<RegistrationDto, Course>();
            CreateMap<ActivityCreateDto, Activity>();
            CreateMap<ActivityModifyDto, Activity>();
            CreateMap<ActivityDto, Activity>();
            CreateMap<EvaluationTypeDto, EvaluationType>();
            CreateMap<EvaluationCreateDto, Evaluation>();
            CreateMap<EvaluationModifyDto, Evaluation>().ForMember(x => x.Id, opt => opt.Ignore());
            CreateMap<EvaluationDetailDto, Evaluation>();
            CreateMap<EvaluationInscriptionDto, EvaluationInscription>();
        }
    }
}
