﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using System;
using System.Collections.Generic;
using System.Text;
using Tsi1.DataLayer.Entities;

namespace Tsi1.DataLayer.EntityConfiguration
{
    public class ForumUserConfiguration : IEntityTypeConfiguration<ForumUser>
    {
        public void Configure(EntityTypeBuilder<ForumUser> builder)
        {
            builder.HasKey(x => new { x.ForumId, x.UserId });

            builder.HasOne(x => x.Forum)
                .WithMany(x => x.ForumUsers)
                .HasForeignKey(x => x.ForumId);

            builder.HasOne(x => x.User)
                .WithMany(x => x.ForumUsers)
                .HasForeignKey(x => x.UserId);
        }
    }
}
