﻿using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace Tsi1.DataLayer.Migrations
{
    public partial class addmultytenancy : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropIndex(
                name: "IX_Users_Username",
                table: "Users");

            migrationBuilder.DropIndex(
                name: "IX_Students_IdentityCard",
                table: "Students");

            migrationBuilder.DropIndex(
                name: "IX_Professors_IdentityCard",
                table: "Professors");

            migrationBuilder.DropIndex(
                name: "IX_Posts_ForumId_Title",
                table: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_Forums_CourseId_Name",
                table: "Forums");

            migrationBuilder.DropIndex(
                name: "IX_Courses_Name",
                table: "Courses");

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Users",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Students",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Professors",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Posts",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "PostMessages",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Forums",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TenantId",
                table: "Courses",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateTable(
                name: "Tenants",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Name = table.Column<string>(type: "character varying(50)", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Tenants", x => x.Id);
                });

            migrationBuilder.CreateIndex(
                name: "IX_Users_TenantId",
                table: "Users",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Users_Username_TenantId",
                table: "Users",
                columns: new[] { "Username", "TenantId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Students_TenantId",
                table: "Students",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Students_IdentityCard_TenantId",
                table: "Students",
                columns: new[] { "IdentityCard", "TenantId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Professors_TenantId",
                table: "Professors",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Professors_IdentityCard_TenantId",
                table: "Professors",
                columns: new[] { "IdentityCard", "TenantId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Posts_TenantId",
                table: "Posts",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Posts_ForumId_Title_TenantId",
                table: "Posts",
                columns: new[] { "ForumId", "Title", "TenantId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_PostMessages_TenantId",
                table: "PostMessages",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Forums_TenantId",
                table: "Forums",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Forums_CourseId_Name_TenantId",
                table: "Forums",
                columns: new[] { "CourseId", "Name", "TenantId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Courses_TenantId",
                table: "Courses",
                column: "TenantId");

            migrationBuilder.CreateIndex(
                name: "IX_Courses_Name_TenantId",
                table: "Courses",
                columns: new[] { "Name", "TenantId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Tenants_Name",
                table: "Tenants",
                column: "Name",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_Courses_Tenants_TenantId",
                table: "Courses",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Forums_Tenants_TenantId",
                table: "Forums",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_PostMessages_Tenants_TenantId",
                table: "PostMessages",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Posts_Tenants_TenantId",
                table: "Posts",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Professors_Tenants_TenantId",
                table: "Professors",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Students_Tenants_TenantId",
                table: "Students",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Users_Tenants_TenantId",
                table: "Users",
                column: "TenantId",
                principalTable: "Tenants",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Courses_Tenants_TenantId",
                table: "Courses");

            migrationBuilder.DropForeignKey(
                name: "FK_Forums_Tenants_TenantId",
                table: "Forums");

            migrationBuilder.DropForeignKey(
                name: "FK_PostMessages_Tenants_TenantId",
                table: "PostMessages");

            migrationBuilder.DropForeignKey(
                name: "FK_Posts_Tenants_TenantId",
                table: "Posts");

            migrationBuilder.DropForeignKey(
                name: "FK_Professors_Tenants_TenantId",
                table: "Professors");

            migrationBuilder.DropForeignKey(
                name: "FK_Students_Tenants_TenantId",
                table: "Students");

            migrationBuilder.DropForeignKey(
                name: "FK_Users_Tenants_TenantId",
                table: "Users");

            migrationBuilder.DropTable(
                name: "Tenants");

            migrationBuilder.DropIndex(
                name: "IX_Users_TenantId",
                table: "Users");

            migrationBuilder.DropIndex(
                name: "IX_Users_Username_TenantId",
                table: "Users");

            migrationBuilder.DropIndex(
                name: "IX_Students_TenantId",
                table: "Students");

            migrationBuilder.DropIndex(
                name: "IX_Students_IdentityCard_TenantId",
                table: "Students");

            migrationBuilder.DropIndex(
                name: "IX_Professors_TenantId",
                table: "Professors");

            migrationBuilder.DropIndex(
                name: "IX_Professors_IdentityCard_TenantId",
                table: "Professors");

            migrationBuilder.DropIndex(
                name: "IX_Posts_TenantId",
                table: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_Posts_ForumId_Title_TenantId",
                table: "Posts");

            migrationBuilder.DropIndex(
                name: "IX_PostMessages_TenantId",
                table: "PostMessages");

            migrationBuilder.DropIndex(
                name: "IX_Forums_TenantId",
                table: "Forums");

            migrationBuilder.DropIndex(
                name: "IX_Forums_CourseId_Name_TenantId",
                table: "Forums");

            migrationBuilder.DropIndex(
                name: "IX_Courses_TenantId",
                table: "Courses");

            migrationBuilder.DropIndex(
                name: "IX_Courses_Name_TenantId",
                table: "Courses");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Users");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Students");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Professors");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Posts");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "PostMessages");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Forums");

            migrationBuilder.DropColumn(
                name: "TenantId",
                table: "Courses");

            migrationBuilder.CreateIndex(
                name: "IX_Users_Username",
                table: "Users",
                column: "Username",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Students_IdentityCard",
                table: "Students",
                column: "IdentityCard",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Professors_IdentityCard",
                table: "Professors",
                column: "IdentityCard",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Posts_ForumId_Title",
                table: "Posts",
                columns: new[] { "ForumId", "Title" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Forums_CourseId_Name",
                table: "Forums",
                columns: new[] { "CourseId", "Name" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Courses_Name",
                table: "Courses",
                column: "Name",
                unique: true);
        }
    }
}
